//+------------------------------------------------------------------+
//|                                                  Dot Mapping.mq5 |
//|                                                      Aleksej1966 |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "Aleksej1966"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#property script_show_inputs
#include <Graphics\Graphic.mqh>
#include <Math\Stat\Stat.mqh>
enum type
  {
   Logistic,Random,Integrated,Price,Linear,Sinus,SinusTrend,Sinus3
  };
input type Type=Logistic;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   MathSrand(GetTickCount());

   int size=MathMin(iBars(_Symbol,PERIOD_CURRENT),TerminalInfoInteger(TERMINAL_MAXBARS));
   double x[],y[],z[],var=M_LN2;
   ArrayResize(x,size);
   ArrayInitialize(x,0);
   ArrayResize(y,size);
   ArrayInitialize(y,0);
   ArrayResize(z,size);
   ArrayInitialize(z,0);

   for(int i=size-1;i>=0;i--)
     {
      if(Type==Logistic)
        {
         z[i]=(1+MathSqrt(8))*var*(1-var);
         var=z[i];
        }

      if(Type==Random)
         z[i]=MathRand();

      if(Type==Integrated)
        {
         int error;
         z[i]=var;
         var=var+MathRandomNormal(0,1,error);
        }

      if(Type==Price)
         z[i]=iOpen(_Symbol,PERIOD_CURRENT,i);

      if(Type==Linear)
         z[i]=size-i+2*MathRandomNonZero()-1;

      if(Type==Sinus)
         z[i]=MathSin(2*M_PI*i/25);

      if(Type==SinusTrend)
         z[i]=1.0*(size-i)/size+MathSin(2*M_PI*i/25);

      if(Type==Sinus3)
         z[i]=3*MathSin(2*M_PI*i/5)+2*MathSin(2*M_PI*i/8)+MathSin(2*M_PI*i/13);
     }

   for(int i=size-1;i>0;i--)
     {
      x[i]=z[i];
      y[i]=z[i-1];
     }

   int cnt=100;
   double v[];
   ArrayResize(v,cnt);
   for(int i=0;i<cnt;i++)
      v[i]=z[size-i-1];

   ChartSetInteger(0,CHART_SHOW,false);
   int w=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0),
       h=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);

   CGraphic graph;
   graph.Create(0,"Graphic",0,0,0,w,h);
   CCurve *ts=graph.CurveAdd(v,CURVE_LINES,EnumToString(Type));
   ts.LinesSmooth(true);
   ts.LinesWidth(2);
   graph.CurvePlotAll();
   graph.Update();
   ChartScreenShot(0,EnumToString(Type)+"_line.png",w,h);
   Sleep(3000);
   graph.CurveRemoveByName(EnumToString(Type));

   CCurve *ch=graph.CurveAdd(x,y,CURVE_POINTS,EnumToString(Type));
   ch.PointsSize(2);
   graph.CurvePlotAll();
   graph.Update();
   ChartScreenShot(0,EnumToString(Type)+"_dotmap.png",w,h);
   Sleep(3000);

   graph.Destroy();
   ChartSetInteger(0,CHART_SHOW,true);
//---
  }
//+------------------------------------------------------------------+
